#!/usr/bin/perl

#Questo programma analizza solo le differenze nel log rispetto
#alla volta precedente, facendo uso del comando diff
#il vecchio log viene salvato a ogni chiamata

$logfile = $ARGV[0];
$oldlogfile = './access_logVecchio';
$oldoldlogfile = './acces_logVecchioVecchio';
$tempfile = './tempfile';

#filtra le righe in elenco che contengono 'ianni' al proprio interno
$filter = 'ianni';

#Il seguente blocco di codice  equivalente al comando:
#qx"grep \"+\"*$filter <$logfile >$tempfile";

open(TEMP,">$tempfile");
open(LOG,"<$logfile");
foreach $linea (<LOG>)
{
    print(TEMP,$linea) if ($linea =~ /$filter/);
}
close LOG;
close TEMP;
  
#analizzando l'output del comando 'diff' scopriamo che le righe aggiunte
#in $tempfile (rispetto a $oldlogfile) sono marcate con un '+'.  
#potrei usare il seguente comando, 
#@n = qx"diff -c1 $oldlogfile $tempfile | grep \"+\"*$filter";
#oppure,

foreach $linea (qx"diff -c1 $oldlogfile $tempfile")
{
    push(@n,$linea) if ($linea =~ /^\+/); 
    #l'espressione regolare /^\+/ identifica le linee 
    #che hanno un '+' come primo carattere. '+' preceduto da '\'.
    #lo '\' serve a indicare che cerco il CARATTERE '+' e non invece
    #che voglio usare '+' come simbolo speciale.
    #l'espressione /^+/ ha significato diverso. 
}

#copio i nuovi file sui vecchi. Mi servir per la prossima volta
#che lancio il programma.
`cp -f $oldlogfile $oldoldlogfile`;
`cp -f $tempfile $oldlogfile`;

#Questo  il ciclo dove estraggo i dati.
foreach $line ( @n ) {
        
        #divido $line in due modi. Per spazi, e per doppi apici.
        @pieces = split(" ",$line);
        @morceaux = split('"',$line);
        #
        $ip = 1; #l'indirizzo IP sta nel secondo elemento di @pieces
        #
        $referrer = 3; #l'URL di provenienza  il quarto elemento di @morceaux
        # 
        $data = 4; #la data sta nel quarto pezzo di @pieces
        #
        $ips{@pieces[$index]} = @morceaux[$referrer]; #Referrer
        $visit{@pieces[$index]} = @pieces[$data];  #Data di visita
        #Cos facendo ho creato due mappe: 
        # IP -> Referrer
        # IP -> Data di visita
        # Notate che se da un certo IP ci sono state pi visite
        # Alla fine mi resteranno solo le informazioni relative
        # all'ultima visita.
}
@tutti = sort keys %ips;
$indirizzo = "miamail@libero.it";
$command = "mail -s [WWW\ Daily\ update] $indirizzo";

#adesso scandisco le due mappe, ordinate per indirizzo IP.
#il comando 'host'  in grado di tradurre un indirizzo IP nel suo nome
#testuale, ammesso che esista.
#provate con un comando 'host 160.97.47.1' per capire come  fatto il suo
#output.

open (INFO, "| $command");
foreach $ip (@tutti) {
        @temp = split( " ", qx"host $ip");
        $name = $temp[$#temp]; 
        #stampo tutte le informazioni che ho, opportunamente formattate, su INFO.
        $ip = $ip."\t\t\t".$name."\nREF: ".substr($visit{$ip},1)." ".$ips{$ip}."\n----\n";
        print INFO $ip;
}
close(INFO);   # Close the file

